<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/* Auto subscribe when order status completed */
$all_plugins = apply_filters('active_plugins', get_option('active_plugins'));
if (stripos(implode($all_plugins), 'woocommerce.php')) {
    
function g9_submailchimp_order_completed( $order_id ) {
$mailchimpstatus = get_post_meta( $order_id, 'mailchimp_status', true );
if( empty($mailchimpstatus) && get_option('g9mailchimpkey') && get_option('g9mailchimpwoolistid'))  {
$order = wc_get_order($order_id);
$data = $order->get_data();
$firstname = $data['billing']['first_name'];
$lastname = $data['billing']['last_name'];
$email = $data['billing']['email'];
$list_id = get_option('g9mailchimpwoolistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
$datatosend = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
		'merge_fields'  => array( 
			'FNAME' => $firstname,
			'LNAME' => $lastname
			) )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $datatosend
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
 {        $result = wp_remote_retrieve_body( $result );

        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
            update_post_meta($order_id, 'mailchimp_status','success');
        }
 }
}  
}

function g9_submailchimp_order_change_to_completed( $order_id, $old_status, $new_status ) {
$mailchimpstatus = get_post_meta( $order_id, 'mailchimp_status', true );
if( $new_status == "completed" && empty($mailchimpstatus) && get_option('g9mailchimpkey') && get_option('g9mailchimpwoolistid'))  {
$order = wc_get_order($order_id);
$data = $order->get_data();
$firstname = $data['billing']['first_name'];
$lastname = $data['billing']['last_name'];
$email = $data['billing']['email'];
$list_id = get_option('g9mailchimpwoolistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
$datatosend = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
		'merge_fields'  => array( 
			'FNAME' => $firstname,
			'LNAME' => $lastname
			) )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $datatosend
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
 {        $result = wp_remote_retrieve_body( $result );

        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
            update_post_meta($order_id, 'mailchimp_status','success');
        }
 }
}  
}

add_action( 'woocommerce_order_status_completed', 'g9_submailchimp_order_completed', 10, 1 ); 
add_action( 'woocommerce_order_status_changed', 'g9_submailchimp_order_change_to_completed', 10, 4 );
}

/* Create footer shortcode */
add_shortcode( 'g9mailchimp', 'g9mailchimp_shortcode' );
function g9mailchimp_shortcode() {
ob_start();
if (get_option('g9mailchimpkey') && get_option('g9mailchimpsublistid')) {
$list_id = get_option('g9mailchimpsublistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
if (isset($_REQUEST['submailchimpfoot']) && wp_verify_nonce($_REQUEST['g9mailchimpfootnonce'],'g9mailchimpfootnonce')) {
$email = $_REQUEST['g9mailchimpaddressfoot'];
$data = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
 )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $data
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
    {
        $result = wp_remote_retrieve_body( $result );

        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
        echo '<div class="g9mailchimpupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9mailchimpredirect')){$redirectdestination = 'Location: '.get_option('g9mailchimpredirect'); header($redirectdestination);die();}; 
        }
        else
        {
			echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry with valid email address.</span></div><br/>';
        }
    } else {echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry.</span></div><br/>';};
}
?>
<form method="post">
<input type="email" aria-label="Input email address" placeholder="Email Address" name="g9mailchimpaddressfoot" class="g9mailchimpaddress">
<?php wp_nonce_field('g9mailchimpfootnonce','g9mailchimpfootnonce'); ?>
<button type="submit"  name="submailchimpfoot" class="g9mailchimpbutton">Subscribe</button>
</form>
<div style="clear:both"></div>
<?php
return ob_get_clean();
}
}

/* Create page shortcode */
add_shortcode( 'g9mailchimpage', 'g9mailchimppage_shortcode' );
function g9mailchimppage_shortcode() {
ob_start();
if (get_option('g9mailchimpkey') && get_option('g9mailchimpsublistid')) {
$list_id = get_option('g9mailchimpsublistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
if (isset($_REQUEST['submailchimppage']) && wp_verify_nonce($_REQUEST['g9mailchimppagenonce'],'g9mailchimppagenonce')) {
$email = $_REQUEST['g9mailchimpaddresspage'];
$data = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
 )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $data
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
    {
        $result = wp_remote_retrieve_body( $result );

        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
        echo '<div class="g9mailchimpupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9mailchimpredirect')){$redirectdestination = 'Location: '.get_option('g9mailchimpredirect'); header($redirectdestination);die();}; 
        }
        else
        {
			echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry with valid email address.</span></div><br/>';
        }
    } else {echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry.</span></div><br/>';};
}
?>
<div class="g9mailchimpageform" style="max-width:<?php echo get_option('g9mailchimpagewidth'); ?>px;margin:auto;margin-top:<?php echo get_option('g9mailchimpagemargintop'); ?>px">
<form method="post">
<input type="email" aria-label="Input email address" placeholder="Email Address" name="g9mailchimpaddresspage" class="g9mailchimpaddress">
<?php wp_nonce_field('g9mailchimppagenonce','g9mailchimppagenonce'); ?>
<button type="submit"  name="submailchimppage" class="g9mailchimpbutton">Subscribe</button>
</form>
<div style="clear:both"></div>
</div>
<?php
return ob_get_clean();
}
}

/* Create section shortcode */
add_shortcode( 'g9mailchimpsection', 'g9mailchimpsection_shortcode' );
function g9mailchimpsection_shortcode() {
ob_start();
if (get_option('g9mailchimpkey') && get_option('g9mailchimpsublistid')) {
$list_id = get_option('g9mailchimpsublistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
if (isset($_REQUEST['submailchimpsection']) && wp_verify_nonce($_REQUEST['g9mailchimpsectionnonce'],'g9mailchimpsectionnonce')) {
$email = $_REQUEST['g9mailchimpaddresssection'];
$data = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
 )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $data
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
    {
        $result = wp_remote_retrieve_body( $result );

        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
        echo '<div class="g9mailchimpupdated"><span style="color:green">Thank you for signing up!</span></div><br/>';
        if (get_option('g9mailchimpredirect')){$redirectdestination = 'Location: '.get_option('g9mailchimpredirect'); header($redirectdestination);die();}; 
        }
        else
        {
			echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry with valid email address.</span></div><br/>';
        }
    } else {echo '<div class="g9mailchimperror"><span style="color:red">Subscription failed. Please retry.</span></div><br/>';};
}
?>
<div id="g9mailchimpsectionblock">
<form method="post">
<input id="g9mailchimpaddresssection" type="email" aria-label="Input email address" placeholder="Email Address" name="g9mailchimpaddresssection" class="g9mailchimpaddress">
<?php wp_nonce_field('g9mailchimpsectionnonce','g9mailchimpsectionnonce'); ?>
<button id="submailchimpsection" type="submit"  name="submailchimpsection" class="g9mailchimpbutton">Subscribe</button>
</form>
<div style="clear:both"></div>
</div>
<?php
return ob_get_clean();
}
}


/* Load style on page */
function g9mailchimp_style() {
?>
<style>
<?php if(get_option('g9mailchimpsublistid')){echo '.g9mailchimpbutton {border:none;font-size:18px;color:'.get_option('g9mailchimpcolor').';background:'.get_option('g9mailchimpbg').';box-shadow: 0 0 0 1px '.get_option('g9mailchimpbg').'}';} ?>
.g9mailchimpupdated {width:calc(100% - 21px);border-left:3px solid green;background: #EFE;padding:9px;color:green  }
.g9mailchimperror {width:calc(100% - 21px);border-left:3px solid red;background: rgb(255,0,0,0.1);padding:9px;color:red }
.g9mailchimpaddress{border:none;font-size:18px;box-shadow: 0 0 0 1px #e3e3e3}
.g9mailchimpbutton{cursor:pointer;}
.g9mailchimpbutton:hover{background:#f1f1f1;color:#595959}
@media (max-width:359px){
.g9mailchimpaddress{display:block;width:calc(100% - 12px);margin-bottom:32px;padding:12px 0px 12px 12px}
.g9mailchimpbutton{display:block;width:100%;margin-bottom:32px;padding:12px 0px 12px 12px}
}
@media (min-width:360px){
.g9mailchimpbutton {display:block;float:left;width:126px;padding:12px;margin-bottom:32px}
.g9mailchimpaddress{display:block;float:left;width:calc(100% - 162px);margin-right:12px;padding:12px;margin-bottom:32px}
}
</style>
<?php
}
add_action( 'wp_head','g9mailchimp_style',99);