<?php
/**
 * Plugin Name: Mailchimp Woocommerce
 * Version:     1.0
 * Description: Automatically send customers data to Mailchimp services
 * Author:      9aman
 * Author URI: https://9aman.com/
 */

//  Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/* Create Plugin Option */
add_action('admin_menu', 'g9mailchimp_option');
function g9mailchimp_option(){
if ( current_user_can( 'setup_network' ) || current_user_can( 'manage_options' ) ) {
$g9mailchimp_menu = add_submenu_page('options-general.php','Mailchimp','Mailchimp' ,'manage_options','g9mailchimp-settings','g9mailchimp_callback');
add_action( 'load-' . $g9mailchimp_menu, 'g9mailchimp_script' );
}
}

/* Call Plugin CSS and JS */
function g9mailchimp_script() {
wp_enqueue_style( 'css-styles', plugin_dir_url( __FILE__ ) . 'css/style.css' );
wp_enqueue_script( 'html5kellycolorpicker', plugin_dir_url( __FILE__ ) . 'js/html5kellycolorpicker.min.js',array('jquery'),NULL);
}

/* Define Plugin Path */
function g9mailchimp_path(){
$pluginurl = plugin_dir_url( __FILE__ );
$parsepluginurl = parse_url($pluginurl, PHP_URL_PATH);
$pluginpath = $_SERVER["DOCUMENT_ROOT"] . $parsepluginurl;
return $pluginpath;
};

/* Register Plugin settings */
add_action( 'admin_init', 'g9mailchimp_field' );
function g9mailchimp_field() {
register_setting("gaman-mailchimp-group", "g9mailchimpexpired");
register_setting("gaman-mailchimp-group", "g9mailchimpkey");
register_setting("gaman-mailchimp-group", "g9mailchimpredirect");
register_setting("gaman-mailchimp-group", "g9mailchimpwoolistid");
register_setting("gaman-mailchimp-group", "g9mailchimpsublistid");
register_setting("gaman-mailchimp-group", "g9mailchimpcolor");
register_setting("gaman-mailchimp-group", "g9mailchimpbg");
register_setting("gaman-mailchimp-group", "g9mailchimpagewidth");
register_setting("gaman-mailchimp-group", "g9mailchimpagemargintop");
}


/* Plugin settings callback */
function g9mailchimp_callback() {
g9mailchimp_activator();
if (get_option('g9mailchimpexpired')) {
echo '<div class="g9themeoptionbg"><div class="g9optfrm">';
if (isset($_REQUEST['connect_mailchimp']) && wp_verify_nonce($_REQUEST['g9mailchimpnonce'],'g9mailchimpnonce')) {
$api_key = $_REQUEST['g9mailchimpkey'];
$redirectdestination = $_REQUEST['g9mailchimpredirect'];
$list_id = $_REQUEST['g9mailchimpwoolistid'];
$list_id2 = $_REQUEST['g9mailchimpsublistid'];
$color = $_REQUEST['g9mailchimpcolor'];
$bg = $_REQUEST['g9mailchimpbg'];
$wdth = $_REQUEST['g9mailchimpagewidth'];
$mrgtop = $_REQUEST['g9mailchimpagemargintop'];
$dc = substr($api_key,strpos($api_key,'-')+1);
$args = array(
	'method' => 'GET',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	)
);
$result = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/ping', $args );
 if( 
        !is_wp_error( $result ) && 
        ( $result['response']['code'] == 200 || $result['response']['code'] == 201 )
    )
    {
        $result = wp_remote_retrieve_body( $result );
        $result = json_decode( $result, TRUE );

        if( !empty( $result ) )
        {
			echo '<div class="g9updated"><span style="color:green">Settings Saved</span></div><br/>';
			update_option('g9mailchimpkey', $api_key);
            update_option('g9mailchimpredirect', $redirectdestination);
			update_option('g9mailchimpwoolistid', $list_id);
			update_option('g9mailchimpsublistid', $list_id2);
			update_option('g9mailchimpcolor', $color);
			update_option('g9mailchimpbg', $bg);
            update_option('g9mailchimpagewidth', $wdth);
            update_option('g9mailchimpagemargintop', $mrgtop);
        } 
    } else { echo '<div class="g9error"><span style="color:red">Invalid API Key</span></div><br/>'; 
				update_option('g9mailchimpkey', ''); 
				update_option('g9mailchimpwoolistid', '');
				update_option('g9mailchimpsublistid', '');
				update_option('g9mailchimpcolor', '');
				update_option('g9mailchimpbg', '');
                update_option('g9mailchimpagewidth', '');
                update_option('g9mailchimpagemargintop', '');}   


}
if (isset($_REQUEST['disconnect_mailchimp']) && check_admin_referer('g9mailchimpnonce')) {
update_option('g9mailchimpkey', '');
update_option('g9mailchimpredirect', '');
update_option('g9mailchimpwoolistid', '');
update_option('g9mailchimpsublistid', '');
update_option('g9mailchimpcolor', '');
update_option('g9mailchimpbg', '');
update_option('g9mailchimpagewidth', '');
update_option('g9mailchimpagemargintop', '');
echo '<div class="g9error"><span style="color:red">Mailchimp Connection Reset</span></div><br/>'; 
}
?>
<form method="post">
<label for="g9mailchimpkey" class="g9commonlabel">Mailchimp's API Key</label>
<input type="password" style="padding:5px 0px 5px 12px" class="g9specialinput" name="g9mailchimpkey" id="g9mailchimpkey" value="<?php echo get_option('g9mailchimpkey'); ?>">
<br/>
<label for="g9mailchimpredirect" class="g9commonlabel">Subscription Success Page URL</label>
<input type="text" style="padding:5px 0px 5px 12px" class="g9specialinput" name="g9mailchimpredirect" id="g9mailchimpredirect" value="<?php echo get_option('g9mailchimpredirect'); ?>">
<br/>
<label for="g9mailchimpwoolistid" class="g9commonlabel">Mailchimp Woocommerce Audience ID</label>
<input type="text" class="g9specialinput" name="g9mailchimpwoolistid" id="g9mailchimpwoolistid" value="<?php echo get_option('g9mailchimpwoolistid'); ?>">
<br/>
<label for="g9mailchimpsublistid" class="g9commonlabel">Mailchimp Subscriber Audience ID</label>
<input type="text" class="g9specialinput" name="g9mailchimpsublistid" id="g9mailchimpsublistid" value="<?php echo get_option('g9mailchimpsublistid'); ?>">
<br/>
<div class="g9commonlabel">Button Style</div>
<table>
<tr>
<td><label for="g9mailchimpcolor" style="display:block;margin-top:5px;margin-bottom:5px">Text Color</label></td>
<td><label for="g9mailchimpbg" style="display:block;margin-top:5px;margin-bottom:5px">BG color</label></td>
</tr>
<tr>
<td><input type="text" class="inputintable colorpicker-custom" name="g9mailchimpcolor" id="g9mailchimpcolor" 
value="<?php  if (get_option('g9mailchimpcolor')){ echo get_option('g9mailchimpcolor'); } else { echo '#595959';} ; ?>"></td>
<td><input type="text" class="inputintable colorpicker-custom" name="g9mailchimpbg" id="g9mailchimpbg" 
value="<?php  if (get_option('g9mailchimpbg')){ echo get_option('g9mailchimpbg'); } else { echo '#f1f1f1';} ; ?>"></td>
</tr>
</table>
<br/>
<div style="clear:both"></div>
<div class="g9commonlabel">Form in page style</div>
<table>
<tr>
<td><label for="g9mailchimpagewidth" style="display:block;margin-top:5px;margin-bottom:5px">Form Width</label></td>
<td><label for="g9mailchimpagemargintop" style="display:block;margin-top:5px;margin-bottom:5px">Form Top Space</label></td>
</tr>
<tr>
<td><input type="text" class="inputintable" name="g9mailchimpagewidth" id="g9mailchimpagewidth" 
value="<?php  if (get_option('g9mailchimpagewidth')){ echo get_option('g9mailchimpagewidth'); } else { echo '800';} ; ?>"></td>
<td><input type="text" class="inputintable" name="g9mailchimpagemargintop" id="g9mailchimpagemargintop" 
value="<?php  if (get_option('g9mailchimpagemargintop')){ echo get_option('g9mailchimpagemargintop'); } else { echo '32';} ; ?>"></td>
</tr>
</table>
<div style="clear:both"></div>
<br/>
<div class="g9spacer"></div>
<?php wp_nonce_field('g9mailchimpnonce','g9mailchimpnonce'); ?>
<button type="submit"  name="connect_mailchimp" class="g9save">Save</button>
<button type="submit" class="g9delsection" name="disconnect_mailchimp">Reset</button>
<div style="clear:both"></div>
</form>
</div></div>
<script>
var colorpickersCustom = KellyColorPicker.attachToInputByClass('colorpicker-custom', {alpha_slider : false, size : 150, popupClass : 'popup-kelly-color-custom'}); 
</script>
<?php
}
}

function g9mailchimp_activator() {
/* Plugin Activation */
echo '<div class="g9themeoptionbg"><div class="g9optfrm">';
$g9mailchimp_activation_key = '5e9867400eccb2.29776240';
$g9mailchimp_activation_url = 'https://9aman.com';
if (isset($_REQUEST['g9mailchimp_validator']) && wp_verify_nonce($_REQUEST['g9mailchimp-activator'],'g9mailchimp-activator')) {
$g9mailchimp_license_key = $_REQUEST['g9mailchimpserial'];
  $api_params = array(
            'slm_action' => 'slm_check',
            'secret_key' => $g9mailchimp_activation_key,
            'license_key' => $g9mailchimp_license_key
        );
$response = wp_remote_get(add_query_arg($api_params, $g9mailchimp_activation_url), array('timeout' => 20, 'sslverify' => false));
$license_data = json_decode(wp_remote_retrieve_body($response));
if($license_data->result == 'error'){
	echo '<div class="g9error"><span style="color:red">Please enter valid serial number.</span></div><br/>';
}
else {
$expiredate = $license_data->date_expiry;
$todate = date("Y-m-d");
if ($todate < $expiredate ) { echo '<div class="g9updated"><span style="color:green">Validation Success</span></div><br/>'; update_option('g9mailchimpexpired', $expiredate);} 
else { echo '<div class="g9error"><span style="color:red">Your serial number was expired. Please renew</span></div><br/>'; delete_option('g9mailchimpexpired');}
}
}
?>
<form method="post">
<label for="g9mailchimpserial" class="g9commonlabel">Serial Number</label>
<input type="password" style="padding:5px 0px 5px 12px" class="g9specialinput" placeholder="Enter your serial number" name="g9mailchimpserial" id="g9mailchimpserial" value="<?php echo get_option('g9mailchimpexpired'); ?>">
<div style="clear:both"></div>
<div class="g9spacer"></div>
<?php wp_nonce_field('g9mailchimp-activator','g9mailchimp-activator'); ?>
<button type="submit"  name="g9mailchimp_validator" class="g9save">Validate</button>
<div style="clear:both"></div>
</form>
<?php
echo '</div></div>';
/* END Plugin Activation */
}

/* AJAX function */
add_action('g9mailchimpajax_g9mailchimp_sendcontact', 'g9mailchimp_sendcontact');
function g9mailchimp_sendcontact() {
if (get_option('g9mailchimpkey') && get_option('g9mailchimpsublistid')) {
$email = $_POST['email'];
$list_id = get_option('g9mailchimpsublistid');
$api_key = get_option('g9mailchimpkey');
$dc = substr($api_key,strpos($api_key,'-')+1);
$data = json_encode(array(
		'email_address' => $email,
		'status'        => 'subscribed',
 )
);
$args = array(
	'method' => 'POST',
 	'headers' => array(
		'Authorization' => 'Basic ' . base64_encode( 'user:'. $api_key )
	),
	'body' => $data
);
$mailchimpfeedback = wp_remote_post( 'https://'.$dc.'.api.mailchimp.com/3.0/lists/'.$list_id.'/members/', $args );
    
 if( 
        !is_wp_error( $mailchimpfeedback ) && 
        ( $mailchimpfeedback['response']['code'] == 200 || $mailchimpfeedback['response']['code'] == 201 )
    )
    {
    $results = 'ok';
    } else {$results = 'nope';};
} else {$results = 'nope';};
echo json_encode($results);
}

/* AJAX JS */
function g9_mailchimp_ajax_js() {
if (is_front_page() && is_home()){
$g9mailchimpendpoint = get_home_url().'/wp-content/plugins/mailchimp-woocommerce/handler/g9mailchimpendpoint.php';
if (get_option('g9mailchimpredirect')){
$redirectdestination = get_option('g9mailchimpredirect');
?>
<script>function js_submit_mailchimp(){return function(e){e.preventDefault();var t=document.getElementById("g9mailchimpaddresssection").value,n=document.getElementById("g9mailchimpsectionnonce").value;if(/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(String(t).toLowerCase())){var o=new FormData;o.append("action","g9mailchimp_sendcontact"),o.append("email",t);var r=new XMLHttpRequest;r.open("POST","<?php echo $g9mailchimpendpoint;?>",!0),r.setRequestHeader("X-WP-Nonce",n),r.onload=function(){"ok"===JSON.parse(this.response)&&(window.location.href="<?php echo $redirectdestination;?>")},r.send(o)}else{document.querySelector(".g9mailchimperror")&&(document.querySelector(".g9mailchimperror").style.display="none");var s=document.createElement("div");s.setAttribute("class","g9mailchimperror"),s.innerHTML="You have entered an invalid email address!",document.getElementById("g9mailchimpsectionblock").appendChild(s)}}}document.getElementById("submailchimpsection")&&document.getElementById("submailchimpsection").addEventListener("click",js_submit_mailchimp());</script>
<?php    
} else {
?>
<script>function js_submit_mailchimp(){return function(e){e.preventDefault();var t=document.getElementById("g9mailchimpaddresssection").value,n=document.getElementById("g9mailchimpsectionnonce").value;if(/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(String(t).toLowerCase())){var o=new FormData;o.append("action","g9mailchimp_sendcontact"),o.append("email",t);var r=new XMLHttpRequest;r.open("POST","<?php echo $g9mailchimpendpoint;?>",!0),r.setRequestHeader("X-WP-Nonce",n),r.onload=function(){if("ok"===JSON.parse(this.response)){document.querySelector(".g9mailchimperror")&&(document.querySelector(".g9mailchimperror").style.display="none");var e=document.createElement("div");e.setAttribute("class","g9mailchimpupdated"),e.innerHTML="Thank you for signing up!",document.getElementById("g9mailchimpsectionblock").appendChild(e)}},r.send(o)}else{document.querySelector(".g9mailchimperror")&&(document.querySelector(".g9mailchimperror").style.display="none");var d=document.createElement("div");d.setAttribute("class","g9mailchimperror"),d.innerHTML="You have entered an invalid email address!",document.getElementById("g9mailchimpsectionblock").appendChild(d)}}}document.getElementById("submailchimpsection")&&document.getElementById("submailchimpsection").addEventListener("click",js_submit_mailchimp());</script>
<?php   
}
    
}
}
add_action( 'wp_footer','g9_mailchimp_ajax_js',225); 


/* Call Plugin Handler */
require_once( g9mailchimp_path().'/handler/handler.php' );

if (get_option('g9mailchimpexpired')) {
/* Updater */
$api_url = 'https://9aman.com/api/';
$plugin_slug = basename(dirname(__FILE__));
// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'g9mailchimp_check_update');

function g9mailchimp_check_update ($checked_data) {
	global $api_url, $plugin_slug, $wp_version;
	
	//Comment out these two lines during testing.
	if (empty($checked_data->checked))
		return $checked_data;

	$args = array(
		'slug' => $plugin_slug,
		'version' => '1.0',
	);
	$request_string = array(
			'body' => array(
				'action' => 'basic_check', 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);
	
	// Start checking for an update
	$raw_response = wp_remote_post($api_url, $request_string);
	
	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);
	
	if (is_object($response) && !empty($response)) // Feed the update data into WP updater
		$checked_data->response[$plugin_slug .'/'. $plugin_slug .'.php'] = $response;
	$todate = date("Y-m-d");
	$expdate = get_option('g9mailchimpexpired');
	if ($todate < $expdate ) {return $checked_data;}
}


// Take over the Plugin info screen
add_filter('plugins_api', 'g9mailchimp_api_call', 10, 3);

function g9mailchimp_api_call($def, $action, $args) {
	global $plugin_slug, $api_url, $wp_version;
	
	if (!isset($args->slug) || ($args->slug != $plugin_slug))
		return false;
	
	// Get the current version
	$plugin_info = get_site_transient('update_plugins');
	$current_version = '1.0';
	$args->version = $current_version;
	
	$request_string = array(
			'body' => array(
				'action' => $action, 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);
	
	$request = wp_remote_post($api_url, $request_string);
	
	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
	} else {
		$res = unserialize($request['body']);
		
		if ($res === false)
			$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
	}
	
	return $res;
}
}